import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Vector;

public interface SystemTypes
{
  public class Set
  { private Vector elements = new Vector();

  public static List select_0(List _l,double x)
  { // Implements: points->select(y | y <= x)
    List _results_0 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double y = ((Double) _l.get(_i)).doubleValue();
      if (y <= x)
      { _results_0.add(new Double(y)); }
    }
    return _results_0;
  }

  public static List select_5(List _l,double l,int i,double step)
  { // Implements: s->select(x | l + i * step <= x & x < l + ( i + 1 ) * step)
    List _results_5 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      if (l + i * step <= x && x < l + ( i + 1 ) * step)
      { _results_5.add(new Double(x)); }
    }
    return _results_5;
  }

  public static List select_7(List _l,List s,int maxfreq)
  { // Implements: s->select(y | s->count(y) = maxfreq)
    List _results_7 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double y = ((Double) _l.get(_i)).doubleValue();
      if (Set.count(s,new Double(y)) == maxfreq)
      { _results_7.add(new Double(y)); }
    }
    return _results_7;
  }






  public static List collect_1(List _l,double m)
  { // implements: s->collect( x | ( x - m ) * ( x - m ) )
    List _results_1 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(( x - m ) * ( x - m ));
      if (collect_x != null) { _results_1.add(collect_x); }
    }
    return _results_1;
  }

  public static List collect_2(List _l,List s,List t)
  { // implements: Integer.subrange(1,s.size)->collect( i | ( s[i] - t[i] ) * ( s[i] - t[i] ) )
    List _results_2 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(( ((Double) s.get(i - 1)).doubleValue() - ((Double) t.get(i - 1)).doubleValue() ) * ( ((Double) s.get(i - 1)).doubleValue() - ((Double) t.get(i - 1)).doubleValue() ));
      if (collect_x != null) { _results_2.add(collect_x); }
    }
    return _results_2;
  }

  public static List collect_3(List _l,List s,double t)
  { // implements: Integer.subrange(1,s.size)->collect( i | ( s[i] - t ) * ( s[i] - t ) )
    List _results_3 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(( ((Double) s.get(i - 1)).doubleValue() - t ) * ( ((Double) s.get(i - 1)).doubleValue() - t ));
      if (collect_x != null) { _results_3.add(collect_x); }
    }
    return _results_3;
  }

  public static List collect_4(List _l,List s)
  { // implements: s->collect( x | s->count(x) )
    List _results_4 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Integer collect_x = new Integer(Set.count(s,new Double(x)));
      if (collect_x != null) { _results_4.add(collect_x); }
    }
    return _results_4;
  }

  public static List collect_6(List _l,double l,double step,List s)
  { // implements: Integer.subrange(0,maxindex)->collect( i | s->select( x | l + i * step <= x & x < l + ( i + 1 ) * step )->size() )
    List _results_6 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Integer collect_x = new Integer((Set.select_5(s,l,i,step)).size());
      if (collect_x != null) { _results_6.add(collect_x); }
    }
    return _results_6;
  }

  public static List collect_8(List _l,List x,int i,List y)
  { // implements: mseq->collect( j | CliffsDelta.diff(x[i],y[j]) )
    List _results_8 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int j = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(CliffsDelta.diff(((Double) x.get(i - 1)).doubleValue(),((Double) y.get(j - 1)).doubleValue()));
      if (collect_x != null) { _results_8.add(collect_x); }
    }
    return _results_8;
  }

  public static List collect_9(List _l,List x,List y,List mseq)
  { // implements: nseq->collect( i | mseq->collect( j | CliffsDelta.diff(x[i],y[j]) ) )
    List _results_9 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      List collect_x = Set.collect_8(mseq,x,i,y);
      if (collect_x != null) { _results_9.add(collect_x); }
    }
    return _results_9;
  }

  public static List collect_10(List _l,CliffsDelta cliffsdeltax)
  { // implements: nseq->collect( i | StatLib.mean(d->at(i)) )
    List _results_10 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(StatLib.mean(((List) cliffsdeltax.getd().get(i - 1))));
      if (collect_x != null) { _results_10.add(collect_x); }
    }
    return _results_10;
  }

  public static List collect_11(List _l,int j)
  { // implements: d->collect( x | x->at(j) )
    List _results_11 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List x = (List) _l.get(_i);
      Double collect_x = new Double(((Double) x.get(j - 1)).doubleValue());
      if (collect_x != null) { _results_11.add(collect_x); }
    }
    return _results_11;
  }

  public static List collect_12(List _l,CliffsDelta cliffsdeltax)
  { // implements: mseq->collect( j | StatLib.mean(d->collect( x | x->at(j) )) )
    List _results_12 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int j = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(StatLib.mean(Set.collect_11(cliffsdeltax.getd(),j)));
      if (collect_x != null) { _results_12.add(collect_x); }
    }
    return _results_12;
  }

  public static List collect_13(List _l,CliffsDelta cliffsdeltax)
  { // implements: sq->collect( z | ( z - delta ) * ( z - delta ) )
    List _results_13 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double z = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(( z - cliffsdeltax.getdelta() ) * ( z - cliffsdeltax.getdelta() ));
      if (collect_x != null) { _results_13.add(collect_x); }
    }
    return _results_13;
  }

  public static List collect_14(List _l,CliffsDelta cliffsdeltax)
  { // implements: d->collect( sq | sq->collect( z | ( z - delta ) * ( z - delta ) )->sum() )
    List _results_14 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { List sq = (List) _l.get(_i);
      Double collect_x = new Double(Set.sumdouble(Set.collect_13(sq,cliffsdeltax)));
      if (collect_x != null) { _results_14.add(collect_x); }
    }
    return _results_14;
  }

  public static List collect_15(List _l,double mu,double sigma)
  { // implements: x->collect( v | ( v - mu ) / sigma )
    List _results_15 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double v = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(( v - mu ) / sigma);
      if (collect_x != null) { _results_15.add(collect_x); }
    }
    return _results_15;
  }

  public static List collect_16(List _l,List y)
  { // implements: Integer.subrange(1,n)->collect( i | AndersonDarling.adNormalTerm(i,y) )
    List _results_16 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { int i = ((Integer) _l.get(_i)).intValue();
      Double collect_x = new Double(AndersonDarling.adNormalTerm(i,y));
      if (collect_x != null) { _results_16.add(collect_x); }
    }
    return _results_16;
  }

  public static List collect_17(List _l,Distribution d1,Distribution d2)
  { // implements: d1.points->collect( x | ( d1.cdf(x) - d2.cdf(x) )->abs() )
    List _results_17 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double x = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(Math.abs(( d1.cdf(x) - d2.cdf(x) )));
      if (collect_x != null) { _results_17.add(collect_x); }
    }
    return _results_17;
  }

  public static List collect_18(List _l,Distribution d2,Distribution d1)
  { // implements: d2.points->collect( z | ( d2.cdf(z) - d1.cdf(z) )->abs() )
    List _results_18 = new Vector();
    for (int _i = 0; _i < _l.size(); _i++)
    { double z = ((Double) _l.get(_i)).doubleValue();
      Double collect_x = new Double(Math.abs(( d2.cdf(z) - d1.cdf(z) )));
      if (collect_x != null) { _results_18.add(collect_x); }
    }
    return _results_18;
  }


    public static boolean equals(List a, List b)
    { return a.containsAll(b) && b.containsAll(a); }


    public Set add(Object x)
    { if (x != null) { elements.add(x); }
      return this; }

    public Set add(int x)
    { elements.add(new Integer(x));
      return this; }

    public Set add(long x)
    { elements.add(new Long(x));
      return this; }

    public Set add(double x)
    { elements.add(new Double(x));
      return this; }

    public Set add(boolean x)
    { elements.add(new Boolean(x));
      return this; }

    public List getElements() { return elements; }


  public static Comparable max(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) < 0) { res = e; } }
    return res; }


  public static Comparable min(List l)
  { Comparable res = null; 
    if (l.size() == 0) { return res; }
    res = (Comparable) l.get(0); 
    for (int i = 1; i < l.size(); i++)
    { Comparable e = (Comparable) l.get(i);
      if (res.compareTo(e) > 0) { res = e; } }
    return res; }


  public static List union(List a, List b)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { Object x = a.get(i); 
      if (x == null || res.contains(x)) { } else { res.add(x); } 
    }
    for (int j = 0; j < b.size(); j++)
    { Object y = b.get(j); 
      if (y == null || res.contains(y)) { } else { res.add(y); }
    }
    return res; }


  public static List subtract(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.removeAll(b);
    return res; }

  public static String subtract(String a, String b)
  { String res = ""; 
    for (int i = 0; i < a.length(); i++)
    { if (b.indexOf(a.charAt(i)) < 0) { res = res + a.charAt(i); } }
    return res; }



  public static List intersection(List a, List b)
  { List res = new Vector(); 
    res.addAll(a);
    res.retainAll(b);
    return res; }



  public static List symmetricDifference(List a, List b)
  { List res = new Vector();
    for (int i = 0; i < a.size(); i++)
    { Object _a = a.get(i);
      if (b.contains(_a) || res.contains(_a)) { }
      else { res.add(_a); }
    }
    for (int j = 0; j < b.size(); j++)
    { Object _b = b.get(j);
      if (a.contains(_b) || res.contains(_b)) { }
      else { res.add(_b); }
    }
    return res;
  }



  public static boolean isUnique(List evals)
  { List vals = new Vector(); 
    for (int i = 0; i < evals.size(); i++)
    { Object ob = evals.get(i); 
      if (vals.contains(ob)) { return false; }
      vals.add(ob);
    }
    return true;
  }


  public static int sumint(List a)
  { int sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { sum += x.intValue(); }
    } 
    return sum; }

  public static double sumdouble(List a)
  { double sum = 0.0; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { sum += x.doubleValue(); }
    } 
    return sum; }

  public static long sumlong(List a)
  { long sum = 0; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { sum += x.longValue(); }
    } 
    return sum; }

  public static String sumString(List a)
  { String sum = ""; 
    for (int i = 0; i < a.size(); i++)
    { Object x = a.get(i); 
      sum = sum + x; }
    return sum;  }



  public static int prdint(List a)
  { int res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Integer x = (Integer) a.get(i); 
      if (x != null) { res *= x.intValue(); }
    } 
    return res; }

  public static double prddouble(List a)
  { double res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Double x = (Double) a.get(i); 
      if (x != null) { res *= x.doubleValue(); }
    } 
    return res; }

  public static long prdlong(List a)
  { long res = 1; 
    for (int i = 0; i < a.size(); i++)
    { Long x = (Long) a.get(i); 
      if (x != null) { res *= x.longValue(); }
    }
    return res;  }



  public static List concatenate(List a, List b)
  { List res = new Vector(); 
    res.addAll(a); 
    res.addAll(b); 
    return res; }




  public static List asSet(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size(); i++)
    { Object obj = a.get(i);
      if (res.contains(obj)) { } 
      else { res.add(obj); }
    } 
    return res; 
  }


  public static List reverse(List a)
  { List res = new Vector(); 
    for (int i = a.size() - 1; i >= 0; i--)
    { res.add(a.get(i)); } 
    return res; }

  public static String reverse(String a)
  { String res = ""; 
    for (int i = a.length() - 1; i >= 0; i--)
    { res = res + a.charAt(i); } 
    return res; }



  public static List front(List a)
  { List res = new Vector(); 
    for (int i = 0; i < a.size() - 1; i++)
    { res.add(a.get(i)); } 
    return res; }


  public static List tail(List a)
  { List res = new Vector(); 
    for (int i = 1; i < a.size(); i++)
    { res.add(a.get(i)); } 
    return res; }


    public static Object first(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static Object last(List v)
    { if (v.size() == 0) { return null; }
      return v.get(v.size() - 1);
    }



  public static List sort(final List a)
  { int i = a.size()-1;
    return mergeSort(a,0,i);
  }

  static List mergeSort(final List a, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,ind1,mid-1);
      a2 = mergeSort(a,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) a1.get(i); 
      Comparable e2 = (Comparable) a2.get(j);
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(e1);
        i++; // get next e1
      } 
      else 
      { res.add(e2);
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List sortedBy(final List a, List f)
  { int i = a.size()-1;
    java.util.Map f_map = new java.util.HashMap();
    for (int j = 0; j < a.size(); j++)
    { f_map.put(a.get(j), f.get(j)); }
    return mergeSort(a,f_map,0,i);
  }

  static List mergeSort(final List a, java.util.Map f, int ind1, int ind2)
  { List res = new Vector();
    if (ind1 > ind2)
    { return res; }
    if (ind1 == ind2)
    { res.add(a.get(ind1));
      return res;
    }
    if (ind2 == ind1 + 1)
    { Comparable e1 = (Comparable) f.get(a.get(ind1)); 
      Comparable e2 = (Comparable) f.get(a.get(ind2));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a.get(ind1)); res.add(a.get(ind2)); return res; }
      else 
      { res.add(a.get(ind2)); res.add(a.get(ind1)); return res; }
    }
    int mid = (ind1 + ind2)/2;
    List a1;
    List a2;
    if (mid == ind1)
    { a1 = new Vector();
      a1.add(a.get(ind1));
      a2 = mergeSort(a,f,mid+1,ind2);
    }
    else
    { a1 = mergeSort(a,f,ind1,mid-1);
      a2 = mergeSort(a,f,mid,ind2);
    }
    int i = 0;
    int j = 0;
    while (i < a1.size() && j < a2.size())
    { Comparable e1 = (Comparable) f.get(a1.get(i)); 
      Comparable e2 = (Comparable) f.get(a2.get(j));
      if (e1.compareTo(e2) < 0) // e1 < e2
      { res.add(a1.get(i));
        i++; // get next e1
      } 
      else 
      { res.add(a2.get(j));
        j++; 
      } 
    } 
    if (i == a1.size())
    { for (int k = j; k < a2.size(); k++)
      { res.add(a2.get(k)); } 
    } 
    else 
    { for (int k = i; k < a1.size(); k++) 
      { res.add(a1.get(k)); } 
    } 
    return res;
  }


  public static List integerSubrange(int i, int j)
  { List tmp = new Vector(); 
    for (int k = i; k <= j; k++)
    { tmp.add(new Integer(k)); } 
    return tmp;
  }

  public static String subrange(String s, int i, int j)
  { return s.substring(i-1,j); }

  public static List subrange(List l, int i, int j)
  { List tmp = new Vector(); 
    for (int k = i-1; k < j; k++)
    { tmp.add(l.get(k)); } 
    return tmp; 
  }



  public static List prepend(List l, Object ob)
  { List res = new Vector();
    res.add(ob);
    res.addAll(l);
    return res;
  }


  public static List append(List l, Object ob)
  { List res = new Vector();
    res.addAll(l);
    res.add(ob);
    return res;
  }


  public static int count(List l, Object obj)
  { int res = 0; 
    for (int _i = 0; _i < l.size(); _i++)
    { if (obj == l.get(_i)) { res++; } 
      else if (obj != null && obj.equals(l.get(_i))) { res++; } 
    }
    return res; 
  }

  public static int count(String s, String x)
  { int res = 0; 
    if ("".equals(s)) { return res; }
    int ind = s.indexOf(x); 
    if (ind == -1) { return res; }
    String ss = s.substring(ind+1,s.length());
    res++; 
    while (ind >= 0)
    { ind = ss.indexOf(x); 
      if (ind == -1 || ss.equals("")) { return res; }
      res++; 
      ss = ss.substring(ind+1,ss.length());
    } 
    return res;
  }



  public static List characters(String str)
  { char[] _chars = str.toCharArray();
    Vector _res = new Vector();
    for (int i = 0; i < _chars.length; i++)
    { _res.add("" + _chars[i]); }
    return _res;
  }



    public static Object any(List v)
    { if (v.size() == 0) { return null; }
      return v.get(0);
    }


    public static List subcollections(List v)
    { Vector res = new Vector();
      if (v.size() == 0)
      { res.add(new Vector());
        return res;
      }
      if (v.size() == 1)
      { res.add(new Vector());
        res.add(v);
        return res;
      }
      Vector s = new Vector();
      Object x = v.get(0);
      s.addAll(v);
      s.remove(0);
      List scs = subcollections(s);
      res.addAll(scs);
      for (int i = 0; i < scs.size(); i++)
      { Vector sc = (Vector) scs.get(i);
        Vector scc = new Vector();
        scc.add(x);
        scc.addAll(sc);
        res.add(scc);
      }
      return res;
    }


  public static Vector maximalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable largest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (largest.compareTo(next) < 0)
      { largest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (largest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }

  public static Vector minimalElements(List s, List v)
  { Vector res = new Vector();
    if (s.size() == 0) { return res; }
    Comparable smallest = (Comparable) v.get(0);
    res.add(s.get(0));
    
    for (int i = 1; i < s.size(); i++)
    { Comparable next = (Comparable) v.get(i);
      if (next.compareTo(smallest) < 0)
      { smallest = next;
        res.clear();
        res.add(s.get(i));
      }
      else if (smallest.compareTo(next) == 0)
      { res.add(s.get(i)); }
    }
    return res;
  }


  public static List intersectAll(List se)
  { List res = new Vector(); 
    if (se.size() == 0) { return res; }
    res.addAll((List) se.get(0));
    for (int i = 1; i < se.size(); i++)
    { res.retainAll((List) se.get(i)); }
    return res;
  }



  public static List unionAll(List se)
  { List res = new Vector(); 
    for (int i = 0; i < se.size(); i++)
    { List b = (List) se.get(i); 
      for (int j = 0; j < b.size(); j++)
      { Object y = b.get(j); 
        if (y == null || res.contains(y)) { } else { res.add(y); } 
      }
    }
    return res;
  }



    public static List concatenateAll(List a)
    { List res = new Vector();
      for (int i = 0; i < a.size(); i++)
      { List r = (List) a.get(i);
        res.addAll(r); 
      }
      return res;
    }



  public static List insertAt(List l, int ind, Object ob)
  { List res = new Vector();
    for (int i = 0; i < ind-1 && i < l.size(); i++)
    { res.add(l.get(i)); }
    if (ind <= l.size() + 1) { res.add(ob); }
    for (int i = ind-1; i < l.size(); i++)
    { res.add(l.get(i)); }
    return res;
  }
  public static String insertAt(String l, int ind, Object ob)
  { String res = "";
    for (int i = 0; i < ind-1 && i < l.length(); i++)
    { res = res + l.charAt(i); }
    if (ind <= l.length() + 1) { res = res + ob; }
    for (int i = ind-1; i < l.length(); i++)
    { res = res + l.charAt(i); }
    return res;
  }


 public static boolean isInteger(String str)
  { try { Integer.parseInt(str); return true; }
    catch (Exception _e) { return false; }
  }


 public static boolean isReal(String str)
  { try { double d = Double.parseDouble(str); 
          if (Double.isNaN(d)) { return false; }
          return true; }
    catch (Exception _e) { return false; }
  }


 public static boolean isLong(String str)
  { try { Long.parseLong(str); return true; }
    catch (Exception _e) { return false; }
  }


  public static boolean oclIsTypeOf(Object x, String E)
  { try { 
    if (x.getClass() == Class.forName(E))
    { return true; } 
    else 
    { return false; }
    } 
    catch (Exception e) { return false; }
  } 


  public static Vector tokeniseCSV(String line)
{ StringBuffer buff = new StringBuffer();
  int x = 0;
  int len = line.length();
  boolean instring = false;
  Vector res = new Vector();
  while (x < len)
  { char chr = line.charAt(x);
    x++;
    if (chr == ',')
    { if (instring) { buff.append(chr); }
      else
      { res.add(buff.toString().trim());
        buff = new StringBuffer();
      }
    }
    else if ('"' == chr)
    { if (instring) { instring = false; }
      else { instring = true; } 
    }
    else
    { buff.append(chr); }
  }
  res.add(buff.toString().trim());
  return res;
}


  public static boolean includesAllMap(Map sup, Map sub)
  { Vector keys = new Vector();
    keys.addAll(sub.keySet());
  
    for (int x = 0; x < keys.size(); x++)
    { Object key = keys.get(x);
      if (sup.containsKey(key))
      { if (sub.get(key).equals(sup.get(key)))
        {}
        else
        { return false; }
      }
      else 
      { return false; }
    }    
    return true;
  }


  public static boolean excludesAllMap(Map sup, Map sub)
  { Vector keys = new Vector();
    keys.addAll(sub.keySet());
  
    for (int x = 0; x < keys.size(); x++)
    { Object key = keys.get(x);
      if (sup.containsKey(key))
      { if (sub.get(key).equals(sup.get(key)))
        { return false; }
      }
    }    
    return true;
  }


  public static Map includingMap(Map m, Object src, Object trg) 
  { Map copy = new HashMap();
    copy.putAll(m); 
    copy.put(src,trg);
    return copy;
  } 


  public static Map excludeAllMap(Map m1, Map m2)  
  { // m1 - m2 
    Vector keys = new Vector(); 
    keys.addAll(m1.keySet()); 
    Map res = new HashMap(); 
   
    for (int x = 0; x < keys.size(); x++) 
    { Object key = keys.get(x); 
      if (m2.containsKey(key)) 
      { } 
      else 
      { res.put(key,m1.get(key));  } 
    }     
    return res; 
  } 


  public static Map excludingMapKey(Map m, Object k)   
  { // m - { k |-> m(k) }   
    Map res = new HashMap();  
    res.putAll(m);  
    res.remove(k);  
    return res;  
  }  


  public static Map excludingMapValue(Map m, Object v) 
  { // m - { k |-> v } 
    Vector keys = new Vector();
    keys.addAll(m.keySet());
    Map res = new HashMap();
  
    for (int x = 0; x < keys.size(); x++)
    { Object key = keys.get(x);
      if (v.equals(m.get(key)))
      { }
      else
      { res.put(key,m.get(key));  }
    }    
    return res;
  }


  public static Map unionMap(Map m1, Map m2) 
  { Map res = new HashMap();
    res.putAll(m1);
    res.putAll(m2);    
    return res;
  }


  public static Map intersectionMap(Map m1, Map m2) 
  { Vector keys = new Vector();
    keys.addAll(m1.keySet());
    Map res = new HashMap();
  
    for (int x = 0; x < keys.size(); x++)
    { Object key = keys.get(x);
      if (m2.containsKey(key) && m1.get(key).equals(m2.get(key)))
      { res.put(key,m1.get(key));  }
    }    
    return res;
  }

  }
}
