# OCL library ocl.py

def sqr(x) : 
  return x*x

def cbrt(x) : 
  return pow(x, 1.0/3)


def isUnique(s) : 
  return len(set(s)) == len(s)

def any(s) : 
  return list(s)[0]



def includesAll(supset,subset) :
  for x in subset :
    if x in supset :
      pass
    else :
      return False
  return True



def excludesAll(supset,subset) :
  for x in subset :
    if x in supset :
      return False
  return True



def exists(col,f) :
  for x in col :
    if f(x) :
      return True
  return False


def forAll(col,f) :
  for x in col :
    if f(x) :
      pass
    else :
      return False
  return True


def exists1(col,f) :
  found = False
  for x in col :
    if f(x) :
      if found :
        return False
      else :
        found = True
  return found


def toLowerCase(str) :
  s = '' + str
  return s.lower()


def toUpperCase(str) :
  s = '' + str
  return s.upper()


def characters(str) :
  res = []
  for x in str :
    res.append('' + x)
  return res


def insertAtString(x,i,s) :
  # i must be > 0
  x1 = x[0:i-1]
  x2 = x[i-1:]
  return x1 + s + x2


def reverseString(st) :
  if len(st) == 0 : 
    return st
  else :
    return reverseString(st[1:]) + st[0:1]
  

def subtractString(s1,s2) :
  res = ''
  for x in s1 :
    if x in s2 :
      pass
    else :
      res = res + x
  return res


def insertAt(x,i,s) :
  # i must be > 0
  x1 = x[0:i-1]
  x2 = x[i-1:]
  x1.extend(s)
  x1.extend(x2)
  return x1


def includingSequence(s,x) :
  res = []
  res.extend(s)
  res.append(x)
  return res


def includingSet(s,x) :
  res = s.copy()
  res.add(x)
  return res


def excludeAllSequence(s1,s2) :
  res = []
  for x in s1 :
    if x in s2 :
      pass
    else :
      res.append(x)
  return res


def excludeAllSet(s1,s2) :
  res = s1.copy()
  return res.difference(s2)


def excludingSequence(s,y) :
  res = []
  for x in s :
    if x == y :
      pass
    else :
      res.append(x)
  return res


def excludingSet(s,x) :
  res = s.copy()
  subtr = {x}
  return res.difference(subtr)


def prepend(s,x) :
  res = [x]
  res.extend(s)
  return res


def append(s,x) :
  res = []
  res.extend(s)
  res.append(x)
  return res


def unionSequence(s,t) :
  res = []
  res.extend(s)
  res.extend(t)
  return res


def unionSet(s,t) :
  res = s.copy()
  return res.union(t)
 

def concatenate(s,t) :
  res = []
  res.extend(s)
  res.extend(t)
  return res
 

def intersectionSequence(s,t) :
  res = [x for x in s if x in t]
  return res


def intersectionSet(s,t) :
  res = s.copy()
  return res.intersection(t) 


def concatenateAll(sq) :
  res = []
  for s in sq : 
    res.extend(s)
  return res


def unionAll(sq) :
  res = set({})
  for s in sq : 
    res = res.union(s)
  return res


def intersectionAllSet(sq) :
  res = any(sq)
  for s in sq : 
    res = res.intersection(s)
  return res


def intersectionAllSequence(sq) :
  res = any(sq)
  for s in sq : 
    res = intersectionSequence(res,s)
  return res


def reverseSequence(s) :
  res = []
  res.extend(s)
  res.reverse()
  return res


def reverseSet(s) :
  return s.copy()


def sortSequence(s) :
  res = []
  res.extend(s)
  res.sort()
  return res


def sortSet(s) :
  return s.copy()


def selectSet(s,f) : 
  return set({x for x in s if f(x)})

def selectSequence(s,f) : 
  return [x for x in s if f(x)]

def rejectSet(s,f) : 
  return set({x for x in s if not f(x)})

def rejectSequence(s,f) : 
  return [x for x in s if not f(x)]

def collectSet(s,f) : 
  return set({f(x) for x in s})

def collectSequence(s,f) : 
  return [f(x) for x in s]

def any1(s,f) : 
  for x in s : 
    if f(x) : 
      return x
  return None



def selectMaximalsSequence(col,f) :
  result = []
  if len(col) == 0 :
    return result
  maximal = f(col[0])
  result = [col[0]]
  for x in col[1:] :
    value = f(x)
    if value > maximal :
      result = [x]
      maximal = value
    else : 
      if value == maximal :
        result.append(x)
  return result
 

def selectMaximalsSet(col,f) :
  result = {}
  elems = col.copy()
  if len(col) == 0 :
    return result
  x = elems.pop()
  maximal = f(x)
  result = {x}
  for y in elems :
    value = f(y)
    if value > maximal :
      result = {y}
      maximal = value
    else : 
      if value == maximal :
        result.add(y)
  return result


def selectMinimalsSequence(col,f) :
  result = []
  if len(col) == 0 :
    return result
  minimal = f(col[0])
  result = [col[0]]
  for x in col[1:] :
    value = f(x)
    if value < minimal :
      result = [x]
      minimal = value
    else : 
      if value == minimal :
        result.append(x)
  return result
 

def selectMinimalsSet(col,f) :
  result = {}
  elems = col.copy()
  if len(col) == 0 :
    return result
  x = elems.pop()
  minimal = f(x)
  result = {x}
  for y in elems :
    value = f(y)
    if value < minimal :
      result = {y}
      minimal = value
    else : 
      if value == minimal :
        result.add(y)
  return result
 

def minSequence(sq) :
  result = sq[0]
  for x in sq :
    if x < result :
      result = x
  return result


def minSet(col) :
  elems = col.copy()
  result = elems.pop()
  for x in elems :
    if x < result :
      result = x
  return result


def maxSequence(sq) :
  result = sq[0]
  for x in sq :
    if x > result :
      result = x
  return result


def maxSet(col) :
  elems = col.copy()
  result = elems.pop()
  for x in elems :
    if x > result :
      result = x
  return result


def sum(col) : 
  result = 0
  for x in col : 
    result += x
  return result


def prd(col) : 
  result = 1
  for x in col : 
    result *= x
  return result

 
def iterate(col,init,f) : 
  result = init
  for x in col : 
    result = f(x,result)
  return result
